//fwn/typedefs.h
#include <stdio.h>
#include <stdlib.h>

typedef size_t st;    typedef st* nst;  st stl, nstl;
typedef div_t dt;     typedef dt* ndt;  st dtl, ndtl;
typedef clock_t ct;   typedef ct* nct;  st ctl, nctl;
typedef FILE* fd;     typedef fd* nfd;  st fdl, nfdl;
typedef void* p;      typedef p* np;    st pl, npl;
typedef void n;

/* nc is used as the type name for a standard C-style string.
  s is used in String.h as a type name for a string with more functionality. */
typedef char c;       typedef c* nc;    st cl, ncl;

typedef unsigned char* b;   typedef b* nb;  st bl, nbl;
typedef int d;              typedef d* nd;  st dl, ndl;
typedef int tf;             typedef tf* ntf;  st tfl, ntfl;
typedef unsigned int u;     typedef u* nu;  st ul, nul;
typedef long ld;            typedef ld* nld;  st ldl, nldl;
typedef unsigned long lu;   typedef lu* nlu;  st lul, nlul;
typedef double f;           typedef f* nf;  st fl, nfl;
typedef long double lf;     typedef lf* nlf;  st lfl, nlfl;

#define typedefs_i \
  stl = sizeof(st);  nstl = sizeof(nst); \
\
  dtl = sizeof(dt);  ndtl = sizeof(ndt); \
  ctl = sizeof(ct);  nctl = sizeof(nct); \
  fdl = sizeof(fd);  nfdl = sizeof(nfd); \
  pl = sizeof(p);  npl = sizeof(np); \
\
  cl = sizeof(c);  ncl = sizeof(nc); \
  bl = sizeof(b);  nbl = sizeof(nb); \
  dl = sizeof(d);  ndl = sizeof(nd); \
  tfl = sizeof(tf);  ntfl = sizeof(ntf); \
  ul = sizeof(u);  nul = sizeof(nu); \
  ldl = sizeof(ld);  nldl = sizeof(nld); \
  lul = sizeof(lu);  nlul = sizeof(nlu); \
  fl = sizeof(f);  nfl = sizeof(nf); \
  lfl = sizeof(lf);  nlfl = sizeof(nlf);

#define begin d main(d argc, nc* argv){ typedefs_i
#define end }
#define m(a) malloc(a)
#define f(p) free(p)
#define tstr typedef struct

/* filewriteno.com plans to use a custom dialect - a way of writing C code.
If that is not used, you do not have to include this copyright.
Only the text beginning with "Copyright (c)" needs to be included.
As long as that text is included, the user will be able to find the site.

fwn/lib.h - Uses printf variable abbreviations as standard type typedef names.
A custom dialect is in order, and the .vimrc is included in the FWNpkg/ folder,
to convert it to standard C code.  That folder is not included with this file.  
This release is only for allowing others to use the typedefs.h.

Attributes of the dialect:
; - replaces ;
* - replaces * (times symbol)
* - replaces * (pointer abbreviation)
/* - begins a multi-line comment
Copyright (c) 2025 filewriteno.com

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any damages
arising from the use of this software.

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must not
   claim that you wrote the original software. If you use this software
   in a product, an acknowledgment in the product documentation would be
   appreciated but is not required.
2. Altered source versions must be plainly marked as such, and must not be
   misrepresented as being the original software.
3. This notice may not be removed or altered from any source distribution.  */
