#include "fwn/lib.h"
#include <linux/fb.h>
#include <string.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <unistd.h>

int main() {
  d fbfd;
  struct fb_var_screeninfo vinfo;
  struct fb_fix_screeninfo finfo;

  // Open the framebuffer device
  fbfd = open("/dev/fb0", O_RDWR);
  if (fbfd == -1) {
    perror("Error opening /dev/fb0");
    return 1;
  }

  // Get variable screen info
  if (ioctl(fbfd, FBIOGET_VSCREENINFO, &vinfo) == -1) {
    perror("Error getting variable screen info");
    close(fbfd);
    return 1;
  }

  // Get fixed screen info
  if (ioctl(fbfd, FBIOGET_FSCREENINFO, &finfo) == -1) {
    perror("Error getting fixed screen info");
    close(fbfd);
    return 1;
  }

  // Print some information
  printf("Resolution: %dx%d\n", vinfo.xres, vinfo.yres);
  printf("Bits per pixel: %d\n", vinfo.bits_per_pixel);
  printf("*ess of framebuffer memory: 0x%lu\n", finfo.smem_start);
  printf("Size of framebuffer memory: %d\n", finfo.smem_len);

  /*Insert */
  
d fb_width=vinfo.xres;
d fb_height=vinfo.yres;
d fb_bpp=vinfo.bits_per_pixel;
d fb_bytes=fb_bpp/8;

d fb_data_size=fb_width*fb_height*fb_bytes;
char *fbdata=mmap(0, fb_data_size, PROT_READ | PROT_WRITE, MAP_SHARED, fbfd, (off_t)0);

memset(fbdata, 255, fb_data_size);
  
  /*/Insert */

  // Close the framebuffer device
  close(fbfd);

  return 0;
}
